class Flow < Array
	
		
	def initialize(trooper)
		@trooper = trooper
		super()
	end
	
	def linear(flowB)
		
		self.clean!
		flowB.clean!
					
		# Lazy textual linear matching between two flows
		res = true
		if self.length == 0 and self.length != flowB.length
			res = false
		else		
			self.each_index{ |i| 
				if not self[i].kind_of?(Metasm::DecodedInstruction) or not flowB[i].kind_of?(Metasm::DecodedInstruction) or 
					self[i].instruction.to_s.gsub('+0]', ']') != flowB[i].instruction.to_s.gsub('+0]', ']')
					res = false
					break			
				end	
			}		
		end	
			
		res
	end	
	
	
	def clean!(soft = true)
		
		return self if self.empty?
		stack = []
		write_flags = false
		read_flags = true

		# This pass should reject all false test and cmp instructions
		# An instruction is flagged as abusive if its effects is overwritten without being read 
		self.reverse!
		self.reject!{ |di|
			res = false
			next if not di.kind_of?(Metasm::DecodedInstruction)

			if not @trooper.disasm.cpu.get_eflags_r(@trooper.disasm, di).empty? and not di.instruction.opname == 'nop'
				read_flags = true
			end
					
			if not @trooper.disasm.cpu.get_eflags_w(@trooper.disasm, di).empty?		
				if read_flags
					read_flags = false
				else
					res = ['test', 'cmp'].include?(di.instruction.opname)
				end			
			end
		
			di.instruction.opname = 'nop' if res
			res
		}
		self.reverse!

		self.each{|di|
			if di.kind_of?(Metasm::DecodedInstruction) and di.opcode.name == 'jmp' and 
			di.instruction.args.first.kind_of?(Metasm::Expression) and 
			@trooper.disasm.normalize(di.instruction.args.first).kind_of?(::Integer)
				di.instruction.opname = 'nop' 	
			end
		}

		# Filter junk call structure... may encountered collateral damages		
		ret_delete = false
		di = self.first	
		while di
			break if not di.kind_of?(Metasm::DecodedInstruction)

			case di.opcode.name				
			when 'push', 'pop'
				stack << di
				
			when 'call'	
				stack << di if di.instruction.args.first.kind_of?(Metasm::Expression) 
				
			when 'add'
				stack << di if esp_inc(di) 
				# acrobatic heuristic should not catch mov [esp], const1; add [esp], const2; part of constant expansion obfuscation.
				stack << di if esp_xref(di) and not (di.instruction.args.last.reduce.div(4) > 32)
				
			when 'ret'
				trash = []
				trash << di
				stack_status = :ok
				args = di.instruction.args.first
				args = (args ? args.reduce : 0).div(4)
				locals = 0
				call_collected = false
				locals_fix = false # ensure that locals variable stack space is fixed strictly once
				return_fix = false # ensure that return address is fixed strictly once
				need_call = (args != 0) ? true : false
				if not need_call
					args+=1 
					stack_status = :pushret
				end
				
				stack.reverse_each{|pdi|
					case pdi.opcode.name
						when 'push'
							pushargExpr = pdi.instruction.args.first.kind_of?(Metasm::Expression) 
  		
							if stack_status == :pushret and args == 1 and pushargExpr 		
								trash << pdi
								args -=1
								break
							elsif need_call and not call_collected and locals > 0 and not pushargExpr
								trash << pdi
								locals  -=1
							elsif need_call and call_collected and args > 0	and not pushargExpr
								trash << pdi
								args  -=1		
								break if args == 0						
							else
								stack_status = :error
								break
							end
							
						when 'pop'
							stack_status = :error # do nothing, should be a legitimate call
							break
							
						when 'call'
							if need_call and not call_collected
								trash << pdi
								call_collected = true
								break if args == 0
							elsif pdi.comment and pdi.comment.to_a.include?('inlined') and not call_collected
								stack_status = :ok
								trash << pdi
								need_call = true
								call_collected = true	
								args -=1
								break if args == 0							
							else
								stack_status = :error
								break
							end
											
						when 'add'
							if stack_status == :pushret
								stack_status = :ok # switch from a push-ret pattern to a call junk
								need_call = true
								args -=1 # CALL instruction is indeed considered as its own argument so we need to decrease counter
								if esp_inc(pdi)
									locals += pdi.instruction.args.last.reduce.div(4)
									locals_fix = true
								else
									return_fix = true
								end
								trash << pdi		
													
							elsif need_call and not call_collected and esp_xref(pdi) and not return_fix
								return_fix = true
								trash << pdi
								
							elsif need_call and not call_collected and esp_inc(pdi) and not locals_fix
								locals_fix = true
								locals += pdi.instruction.args.last.reduce.div(4) if esp_inc(pdi)	
								trash << pdi		
																	
							else	
								stack_status = :error
								break
								
							end
					end	
				}
				
				rejected = []
				if stack_status != :error
					if not trash.empty? and
						((need_call and call_collected and args == 0 and locals == 0) or # call-junk
						(stack_status == :pushret and not need_call and not call_collected and args == 0 and locals == 0)) # push-ret junk
												
						di = get_next(di) # backup next instruction before deleting ret instruction
						ret_delete = true
						
						trash.each{|ddi| 
							ddi.add_comment 'trashed' if not (ddi.comment and ddi.comment.to_a.include?('trashed'))
							ddi.instruction.opname = 'nop'
							stack.delete(ddi)
							self.delete(ddi)
						}
						
					end
				end
				#-------------------------------------------------------------------------------------
			end
			
			di = get_next(di) if not ret_delete
			ret_delete &= (not ret_delete)
		end

	self.delete_if{|di| di.kind_of?(Metasm::DecodedInstruction) and di.instruction.opname == 'nop'}		
	self.each{|di|
		next if not di.kind_of?(Metasm::DecodedInstruction)
		case di.opcode.name
		when 'mov'
			if ndi = get_next(di) and ndi.kind_of?(Metasm::DecodedInstruction) and
				(ndi.instruction.opname == 'add'or ndi.instruction.opname == 'sub') and di.instruction.args.first.to_s == ndi.instruction.args.first.to_s and
				Expression[di.instruction.args[1]].reduce.kind_of?(::Integer) and Expression[ndi.instruction.args[1]].reduce.kind_of?(::Integer)

				di.instruction.args[1] = Expression[Expression[[di.instruction.args[1], (ndi.instruction.opname  == 'add' ? :+ : :-), ndi.instruction.args[1]], :&, 0xFFFF_FFFF].reduce]
				ndi.instruction.opname = 'nop'							
			end
		end
	}	if not soft
	self.delete_if{|di| di.kind_of?(Metasm::DecodedInstruction) and di.instruction.opname == 'nop'}	
	self
	end
	
	
	def esp_xref(di)
		di.to_s.sub('nop', di.opcode.name).match(/add dword ptr \[esp/)
	end
	
	def esp_inc(di)
		di.to_s.sub('nop', di.opcode.name).match(/add esp,/)
	end
	
	def get_next(di)
		pos = self.index(di)
		if pos
			self[pos+1]
		else
			nil
		end
	end
	
	
end



