#!/usr/bin/env ruby

require 'metasm'
include Metasm
require 'metasm_patch'
require 'flow'
require 'treetment'
require 'dump_graphml'

no_data = ARGV.delete('--no-data')
no_data_trace = ARGV.delete('--no-data-trace')
exename = 'poeut.exe'
cheader = 'poeut.h'

exe = AutoExe.decode_file exename
exe.cpu = Ia32.new

d = exe.init_disassembler
d.parse_c_file cheader if cheader
d.backtrace_maxblocks_data = -1 if no_data_trace

ep_main = [0x401000, 0x401290, 0x402b30, 0x40bdf8]
ep_main = [0x401000, 0x401018, 0x40116a, 0x401171, 0x408a92, 0x40C2C0, 0x4093E0]	# noreturn retaddrs
ep_main = [0x401000]
ep_main = [0x401000, 0x40116a]

if ARGV.empty?
	ep = ep_main
else
	ep = ARGV.map { |ep| Integer(ep) }
end

puts 'The bugle sounds as the charge begins'

begin
	exe.disassemble(*ep)
	ep_back = ep.clone
  puts 'dump raw'
  File.open('poeut.raw.asm', 'w') { |fd| d.dump(!no_data) { |l| fd.puts l } }
  
  ep_back.each { |entrypoint|
    trooper = Treetment.new(d, entrypoint)
    trooper.reduce(entrypoint)
    trooper.merge_dups(entrypoint)
    trooper.merge_clean(entrypoint)
  }  
  
rescue Interrupt
	puts $!, $!.backtrace
end


puts 'dump graphml'
dump_graphml('poeut.graphml', d, ep.dup)

puts 'dump reordered'
dump_asm('poeut.asm', d, ep.dup)

puts "\nWe wont live to fight another day"

