require 'metasm'
include Metasm

file = 'poeut.exe'

pe = PE.decode_file file
elf = ELF.new pe.cpu_from_headers
pe.sections.each { |s|
	es = ELF::Section.new
	es.name = s.name
	es.type = 'PROGBITS'
	es.flags = ['ALLOC'] + s.characteristics.map { |f|
		case f
		when 'MEM_WRITE': 'WRITE'
		when 'MEM_EXECUTE': 'EXECINSTR'
		end
	}.compact
	es.addr = s.virtaddr + pe.optheader.image_base
	es.encoded = s.encoded
	elf.sections << es
}


elf.parse <<'EOS'
.pt_gnu_stack rw
.entrypoint hooked_entrypoint
hooked_entrypoint:
	; need a huuuuge stack => heap
	push 0x80100
	call malloc
	add esp, 4
	lea ebp, [eax+0x80000]

	; disable gnulibc init (weird things w/ FindAtomA)
	or dword ptr [40fc00h], 1

	; init argc/argv/envp as args for main
	mov ecx, [esp]
	mov [ebp], ecx
	lea eax, [esp+4]
	mov [ebp+4], eax
	lea eax, [eax+4*ecx+4]
	mov [ebp+8], eax

	; call main
	mov esp, ebp
	mov eax, 403db0h
	call eax
	
	; exit
	mov eax, 1
	mov ebx, 0
	int 80h

puts:
	push [esp+4]
	push puts_format
	call printf
	add esp, 8
	ret
puts_format db "%s\n\0"

; unused IAT symbols
SetUnhandledExceptionFilter:
AddAtomA:
FindAtomA:
GetAtomNameA:
ExitProcess:
signal:
_iob:
_onexit:
_cexit:
__set_app_type:
_setmode:
__getmainargs:
__p__environ:
__p__fmode:
	int 3
EOS
elf.assemble
elf.header.ident = 0.chr*14+4.chr+0.chr		# chpax -m
elf.encode_file file.sub('.exe', '')
