class Treetment
	
	attr_accessor :disasm
	
	MAX_REC = 20
	MAX_REC_LITE = 100
	MAX_BLOC = 32
	
	def initialize(disasm, ep)
		@stack = []
		@disasm = disasm
		@counter = 0
		@current, @nextb,  @prevb = nil, [], []
		update(ep)		
		puts "\nWe get so close near, enough to fight"
	end
	
	private
		
	
	def push_context
		@stack << @current
	end
	
	
	def pop_context
		@current = @stack.pop
		update(@current.address)		
	end
	
	
	def update(addr)
		if di = @disasm.decoded[addr]
			@current, @nextb,  @prevb = di.block, [], []
			
			if @current.to_subfuncret
				@current.each_to_subfuncret{|addr| (di = @disasm.decoded[@disasm.normalize(addr)]) ? (@nextb << di.block) : nil}
			else
				@current.each_to_normal{|addr| (di = @disasm.decoded[@disasm.normalize(addr)]) ? (@nextb << di.block) : nil}
			end
			
			if @current.from_subfuncret
				@current.each_from_subfuncret{|addr| (di = @disasm.decoded[@disasm.normalize(addr)]) ? (@prevb << di.block) : nil}
			else
				@current.each_from_normal{|addr| (di = @disasm.decoded[@disasm.normalize(addr)]) ? (@prevb << di.block) : nil}
			end			
			
		else
			raise MyExc, "address is not covered #{Metasm::Expression[addr]}"
		end	
	end
		
	
	def reduce_twin_blocks(block, rec = MAX_REC)
		
		raise MyExc if @nextb.length != 2
		res = false
		
		if @nextb.first.is_cond_block and @nextb.last.is_cond_block and
			@nextb.first.list.last.instruction.to_s == @nextb.last.list.last.instruction.to_s

			may_match =  (@nextb.first.to_normal.to_a | @nextb.last.to_normal.to_a) - (@nextb.first.to_normal.to_a & @nextb.last.to_normal.to_a)

			if @disasm.decoded[may_match.first] and @disasm.decoded[may_match.last] and
				match_flow(@disasm.decoded[may_match.first].block, @disasm.decoded[may_match.last].block, rec-1)
			  
				unlink(block)
				res= true		
				puts "duplicated flow (inverse) at #{Expression[@current.address]}" if $DEBUG
			end
			
		elsif match_flow(@nextb.first, @nextb.last, rec-1)
		
			unlink(block)
			res= true	
			puts "duplicated flow at #{Expression[@current.address]}" if $DEBUG
			
		end
		
		res
	end
		
	
	def unlink(block)
		update(block.address)
		@counter += 1
		@current.list.last.instruction.opname = 'nop'
		@current.list.last.add_comment('duplicated flow')
		@current.to_normal = [ @nextb.last.address]		
		@nextb.first.from_normal.kind_of?(::Array) ? @nextb.first.from_normal -= [@current.address] : @nextb.first.from_normal = []
		puts "keep block at #{Expression[@nextb.last.address]}", "unlink block at #{Expression[@nextb.first.address]}" if $DEBUG
	end
	
	
	def match_flow(left_block, right_block, rec)

		locals = [{@current.address=>true}, {@current.address=>true}]		
		leftFlow = deep_go(left_block, locals, :left, rec)
		rightFlow = deep_go(right_block, locals, :right, rec)
		
		return false if leftFlow.last == :not_releavant and not rightFlow.last == :diamond
		return false if (leftFlow.length == 1 and leftFlow.first == :not_releavant)
		
		res = false
		if leftFlow and rightFlow 
			if rightFlow.last == :diamond
				rightFlow.pop	
				begin
					leftFlow[leftFlow.index(rightFlow.last)+1..-1] = []
				rescue
					# FIXME
					leftFlow = Flow.new(self)
				end
			end
			backLeft = leftFlow.dup
			res = leftFlow.linear rightFlow
		end
		# FIXME 
		if res
			backLeft.pop
			backLeft.each{|di|
				next if not di.kind_of?(Metasm::DecodedInstruction)
				di.add_comment 'deleted'
			}
		end
		res
	end		
		
	
	
	def deep_go(block, locals, side, rec = MAX_REC, flow = Flow.new(self))
		push_context
		update(block.address)
		post = false	
		
		if rec <= 0
			post = :not_releavant
			
		elsif block and rec > 0
			update(block.address)
   			puts "* deep go at: #{Expression[block.address]} ; rec: #{rec}" if $DEBUG  
			
			if locals[(side ==  :left ) ? 0 : 1][block.address]
				rec = 0
				post = :loop
			elsif locals[(side ==  :left ) ? 1 : 0][block.address]
				rec = 0		
				
				# Get first non-nopped shared instruction in a diamond pattern.			
				no_nop = nil		
				block.list.each{|di|
					flow << di
					no_nop = di if not di.instruction.opname == 'nop'
					break if no_nop
				}				
				
				push_context
				while not no_nop
					if @nextb.first
						update(@nextb.first.address)
					else
						break
					end
					@current.list.each{|di|
						flow << di
						no_nop = di if not di.instruction.opname == 'nop'
						break if no_nop
					}
				end
				pop_context	
				post = :diamond	
			end
			
			# So far, so good		
			if not post
	
				locals[ (side == :left) ? 0 : 1][block.address] = true
				di = block.list.last
				flow.concat block.list
				
				
				# conditionnal jump
				if di and di.opcode.props[:setip] and not di.opcode.props[:stopexec] and @nextb.length == 2
										
					puts "\n-------------------- new context for conditionnal jump \n\n"  if $DEBUG			
					push_context
					res = reduce_twin_blocks(block, rec-1)
					puts "res = #{res}" if $DEBUG
					pop_context	
					puts "-------------------- back from context \n\n" if $DEBUG 	
					
					if res and @nextb.length == 1
						flow.pop	
						deep_go(@nextb.first.dup, locals, side, rec-1, flow)
					end  #FIXME# This case may cause false-positive, then try with	else flow << block.list #:not_releavant
					

				# call instruction
				elsif di and (di.instruction.opname == 'call' or (di.comment and di.comment.to_a.include?('inlined'))) and 
					di.instruction.args.first.kind_of?(::Expression) and block.to_subfuncret
										
					# inline function smaller than 32 bloc (may cause problems with diamond patterns)
					if target = inline_enable()
						di.add_comment 'inlined'
						deep_go(@disasm.decoded[target].block, locals, side, rec-1, flow)
					end
													
					# then follow standard path
					deep_go(@nextb.first.dup, locals, side, rec-1, flow) if not flow.last.kind_of?(::Symbol)

				# default case
				elsif @nextb and @nextb.length <= 1
					deep_go(@nextb.first.dup, locals, side, rec-1, flow) if  @nextb.length == 1
					
				# error case
				else
					post = :not_releavant
					
				end
			end
		end
		
		flow << post if post	
		pop_context
		flow
	end
		
	
	def deep_go_lite(block, locals =[], rec = MAX_REC_LITE, flow = Flow.new(self))	
		push_context
		update(block.address)
		post = false	
		
		if rec <= 0
			raise 'should be a loop'
			
		elsif block and rec > 0
			update(block.address)
			locals << block.address
	   		puts "* deep go lite at: #{Expression[block.address]} ; rec: #{rec}" if $DEBUG  
			
			di = block.list.last
			flow.concat block.list
				
			# call instruction
			if di and (di.instruction.opname == 'call' or (di.comment and di.comment.to_a.include?('inlined'))) and 
				di.instruction.args.first.kind_of?(Metasm::Expression) and
				@disasm.normalize(di.instruction.args.first).kind_of?(::Integer) and block.to_subfuncret
									
				# inline function smaller than 32 bloc (may cause problems with diamond patterns)
				if target = inline_enable()	
					di.add_comment 'inlined'
					deep_go_lite(@disasm.decoded[@disasm.normalize(target)].block, locals, rec-1, flow)
					@disasm.decoded[@disasm.normalize(locals.last)].block.to_normal =  @current.to_subfuncret
					@current.to_subfuncret = nil
					update(locals.last)
				end
			end
			
			if @nextb.first and @nextb.first.from_normal
				@nextb.first.from_normal.reject!{|addr|
					res = false
					if di = @disasm.decoded[@disasm.normalize(addr)] and di.comment.to_a.include?('deleted')
						res = true
					end
					res
				}
				@nextb.first.from_normal = nil if @nextb.first.from_normal.length == 0
			end

			if (@current.to_subfuncret.to_a + @current.to_normal.to_a).length == 1 and @nextb.first and
				(@nextb.first.from_subfuncret.to_a + @nextb.first.from_normal.to_a).length <= 1
				deep_go_lite(@nextb.first.dup, locals, rec-1, flow)	
			end
		end
		
		pop_context
		flow
	end
	
	
	def inline_enable()
		# count blocks in function body, returns an target address if ti is possib le to inline this function, nil if not.
		todo = []
		target = nil
		
		@current.each_to_normal{|addr| (ddi = @disasm.decoded[@disasm.normalize(addr)]) ? (todo << ddi.block.address) : nil}
		if todo.first and f = @disasm.function[todo.first] and f.return_address and
				f.return_address.all? { |ra| @disasm.decoded[ra].opcode.name == 'ret' }
			target = todo.first
			
			@inline ||= {}
			if not block_count = @inline[target]
				
				fblocks = []
				while addr = todo.pop
					next if fblocks.include? addr or not @disasm.decoded[addr]
					fblocks << addr
					b = @disasm.decoded[addr].block
					if b.to_subfuncret
						b.each_to_subfuncret { |to| todo << @disasm.normalize(to) }
					else
						b.each_to_normal { |to| todo << @disasm.normalize(to) }
					end
				end
				
				fblocks.delete_if { |b| @disasm.decoded[b].block.list.empty? or @disasm.decoded[b].block.list.last.opcode.name == 'jmp' }	# try to count real blocks only...
				block_count = @inline[target] = fblocks.length
				if fblocks.find { |b| @disasm.decoded[b].block.list.find { |di| di.opcode.name == 'pop' or di.opcode.name == 'leave' } }
					block_count = @inline[target] = MAX_BLOC * 12	# do not inline function with a pop
				end
				puts "- inline target : #{Expression[target]} with #{block_count} blocs\n\n" if $DEBUG
			end		
			target = false if not block_count <= MAX_BLOC		
		end
		
		target
	end
	
	
	public
	
	
	def reduce(start_addr)
		t1 = Time.now
		todo = [@disasm.normalize(start_addr)]
		done = []
		puts "* start to reduce at #{Expression[start_addr]}"
		
		while current_addr = @disasm.normalize(todo.pop)
			next if done.include? current_addr
			begin
				update(current_addr)
				done << current_addr
						
				@current.each_to{|addr, boolean|todo << @disasm.normalize(addr)}
				@current.each_from{|addr, boolean| todo << @disasm.normalize(addr)}	
					
				deep_go(@current, [{},{}], :left) if @current.is_cond_block	
							
			rescue MyExc
				done << current_addr 
			end
		end
		
		puts "#{@counter} twin_blocks have been neutralized"
		dt = Time.now - t1
		puts "temps mis: #{dt.to_i/60}mn#{dt%60}\n"	
	end	
	
	
	def merge_clean(start_addr, soft = true)
		t1 = Time.now
		todo = [start_addr]
		done = []
		puts "* start to clean at #{Expression[start_addr]}"
		
		while current_addr = @disasm.normalize(todo.pop)
			next if done.include? current_addr
			begin
				done << current_addr
				update(current_addr)
				flow = deep_go_lite(@current, locals = [])	
					
				firstb = @disasm.decoded[@disasm.normalize(locals.first)].block
				lastb  = @disasm.decoded[@disasm.normalize(locals.last)].block
			
				flow.clean!(soft_clean = false)
				if soft
					firstb.list = flow #if not flow.empty?
					firstb.to_normal = lastb.to_normal
					firstb.to_subfuncret = lastb.to_subfuncret
					firstb.to_indirect = lastb.to_indirect
				end
				lastb.each_to { |addr, type| todo << addr }
			rescue MyExc
				done << current_addr 
			end
		end
		
		dt = Time.now - t1
		puts "temps mis: #{dt.to_i/60}mn#{dt%60}"		
	end
	
	
  def merge_dups(entrypoint)
    todo = [entrypoint]
    done = []
    seen = {} # di.address => block
    while addr = todo.pop
      addr = @disasm.normalize(addr)
      next if done.include? addr or not @disasm.decoded[addr]
      done << addr
      block = @disasm.decoded[addr].block
      block.each_to { |a, b| todo << a }
      block.list.each { |di|
        if seen[di.address]
          other = @disasm.decoded[seen[di.address]].block
          if di == block.list.first
            other.list[other.list.index(di)..-1] = []
            other.to_normal = [block.address]
            other.to_subfuncret = nil
  
            block.list.each { |di| seen[di.address] = block.address }
          elsif di == other.list.first
            block.list[block.list.index(di)..-1] = []
            block.to_normal = [other.address]
            block.to_subfuncret = nil
          else
            newblock = block.dup
            newblock.address = di.address
            newblock.list = block.list[block.list.index(di)..-1]
            newblock.to_normal = block.to_normal
            newblock.to_subfuncret = block.to_subfuncret
  
            block.list[block.list.index(di)..-1] = []
            block.to_normal = [newblock.address]
            block.to_subfuncret = nil
            other.list[other.list.index(di)..-1] = []
            other.to_normal = [newblock.address]
            other.to_subfuncret = nil
  
            newblock.list.each { |di| seen[di.address] = newblock.address }
          end
          break
        else
          seen[di.address] = block.address
        end
      }
    end
    
  end	
	
end

